/* 
* Rootfly:  A program for analyzing and measuring roots. 
* Copyright (c) 2007 Clemson University.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or (at
* your option) any later version.
* 
* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 

// @author: Clemson University ECE417 Spring 2007-2010

// Rootfly.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Rootfly.h"
#include "RootflyDlg.h"
#include "Test.h"  // for the test code

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CRootflyApp

BEGIN_MESSAGE_MAP(CRootflyApp, CWinApp)
//{{AFX_MSG_MAP(CRootflyApp)
// NOTE - the ClassWizard will add and remove mapping macros here.
//    DO NOT EDIT what you see in these blocks of generated code!
//}}AFX_MSG
ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRootflyApp construction

CRootflyApp::CRootflyApp()
{
  // TODO: add construction code here,
  // Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CRootflyApp object

CRootflyApp theApp;

// If the first command line parameter is equal to "/test_the_rootfly_code", then the test code is run and 
// the program exits
void CheckWhetherToRunJustTheTestCodeRatherThanTheRootflyApplication()
{
  CString test_code = "/test_the_rootfly_code";
  
  LPWSTR *szArglist;
  int nArgs;
  szArglist = CommandLineToArgvW(GetCommandLineW(), &nArgs);
  
  if (nArgs >= 2) 
  {
    CString cmd_line_param;
    cmd_line_param.Format("%ws",szArglist[1]);  // the 'w' causes an ASSERT to fire, even though it works -- STB 4/20/10
    if (strncmp(cmd_line_param, test_code, test_code.GetLength()) == 0)
    {
      RootflyTester::MainTest();
      exit(0);
    }
  }
}

/////////////////////////////////////////////////////////////////////////////
// CRootflyApp initialization

BOOL CRootflyApp::InitInstance()
{
  CheckWhetherToRunJustTheTestCodeRatherThanTheRootflyApplication();
  
  AfxEnableControlContainer();
  
  // Standard initialization
  // If you are not using these features and wish to reduce the size
  //  of your final executable, you should remove from the following
  //  the specific initialization routines you do not need.
  
#ifdef _AFXDLL
  Enable3dControls();			// Call this when using MFC in a shared DLL
#else
  Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif
  
  // required for registry operations
  // ( HKEY_CURRENT_USER\Software\Clemson ECE 417 )
  SetRegistryKey(_T("Clemson ECE 417"));
  
  // load accelerator for keyboard shortcuts
  m_haccel = LoadAccelerators(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_ACCELERATOR1));
  
  CRootflyDlg dlg;
  m_pMainWnd = &dlg;
  int nResponse = dlg.DoModal();
  if (nResponse == IDOK)
  {
    // TODO: Place code here to handle when the dialog is
    //  dismissed with OK
  }
  else if (nResponse == IDCANCEL)
  {
    // TODO: Place code here to handle when the dialog is
    //  dismissed with Cancel
  }
  
  // Since the dialog has been closed, return FALSE so that we exit the
  //  application, rather than start the application's message pump.
  return FALSE;
}

BOOL CRootflyApp::PreTranslateMessage(MSG* pMsg) 
{
  if(m_haccel)
  {
    // translate keyboard shortcuts using accelerator
    BOOL ret = ::TranslateAccelerator(m_pMainWnd->m_hWnd, m_haccel, pMsg);
    if (ret)
      return TRUE;
  }	
  
  return CWinApp::PreTranslateMessage(pMsg);
}
